#include<stdio.h>
int main(){
    unsigned n,q,p[300000],dan,kol,poj; int i,j; unsigned long long k[300000],d[300000];
    scanf("%u%u",&n,&q);
    for(i=0;i<n;i++){
        scanf("%llu %u",&d[i],&p[i]);
    }
    for(j=0;j<q;j++){
        scanf("%llu",&k[j]);
    }

    for(j=0;j<q;j++){
        i=0;
        kol=0;
        poj=0;
    for(dan=1;dan<=k[j];dan++){
        if(dan==d[i]){
            kol+=p[i];
            if(i<n-1)i++;
        }
        if(kol>0){
            kol--;
            poj++;
        }


    }
    printf("%u",poj);
    }
    return 0;
}